<template>
  <v-row justify="center">
    <v-col cols="12" class="d-flex align-center justify-space-between">
      <h1>Liste des produits</h1>
      <Toolbar :handle-add="addHandler" />
    </v-col>

    <v-col cols="12">
      <v-text-field v-model="search" placeholder="Recherche par nom de produit"></v-text-field>

      <v-data-table
        v-model="selected"
        :headers="headers"
        :items="filteredItems"
        :loading="isLoading"
        :loading-text="$t('Chargement...')"
        class="elevation-1"
        item-key="@id"
        :custom-sort="customSort"
        @update:options="onUpdateOptions"
      >
        <template
          v-slot:item.notation="{ item }"
        >{{item.comments.length > 0 ? Math.round(item.notation * 100) / 100 : "Produit non noté"}}</template>

        <template v-slot:item.price="{ item }">{{item.price + "€"}}</template>

        <template v-slot:item.store="{ item }">
          {{productCompany(item).street}},
          {{productCompany(item).zc}} -
          {{productCompany(item).city}},
          {{productCompany(item).country}}
        </template>

        <template v-slot:item.detail="{ item }">
          <router-link
            style="text-decoration: none; margin-right: 5px;"
            :to="{ name: 'ProductShow', params: {id: item.id} }"
          >
            <v-icon style="text-decoration: none;">mdi-eye</v-icon>
          </router-link>
        </template>

        <template v-slot:item.editer="{ item }">
          <router-link
            style="text-decoration: none; margin-right: 5px;"
            :to="{ name: 'AdminProductUpdate', params: {id: item.id} }"
          >
            <v-icon style="text-decoration: none;">mdi-pencil</v-icon>
          </router-link>
        </template>
      </v-data-table>
    </v-col>
  </v-row>
</template>

<script>
import { mapActions, mapGetters } from "vuex";
import { mapFields } from "vuex-map-fields";
import ListMixin from "../../../mixins/ListMixin";
import Toolbar from "../../../components/Toolbar";

export default {
  name: "AdminProductList",
  servicePrefix: "AdminProduct",
  mixins: [ListMixin],
  components: {
    Toolbar
  },
  data() {
    return {
      headers: [
        { text: "Nom", value: "name", sortable: false },
        { text: "Prix", value: "price", sortable: false },
        { text: "Notation", value: "notation", sortable: false },
        { text: "Magasin", value: "store", sortable: false },
        { text: "Détail", value: "detail", sortable: false },
        { text: "Editer", value: "editer", sortable: false }
      ],
      selected: [],
      search: ""
    };
  },
  computed: {
    ...mapGetters("adminProduct", {
      items: "list"
    }),
    ...mapFields("adminProduct", {
      deletedItem: "deleted",
      error: "error",
      isLoading: "isLoading",
      resetList: "resetList",
      totalItems: "totalItems",
      view: "view"
    }),
    ...mapFields("admin", ["company", "companyFound"]),
    ...mapFields("user", ["userInfos", "loggedIn"]),
    filteredItems() {
      if (this.company.stores !== undefined) {
        return this.company.stores
          .flatMap(store => store.products)
          .filter(item => {
            return item.name.toLowerCase().includes(this.search.toLowerCase());
          });
      }
      return [];
    }
  },
  created() {
    if (this.userInfos) {
      this.getProfile(this.userInfos.id);
      this.setProductLoadedState(false);
    }
  },
  watch: {
    // company.stores.flatMap(store => store.products)
    companyFound(newData) {
      if (newData) {
        this.getStoresByCompany(this.company.id);
      }
    },
    userInfos(newData) {
      if (newData) {
        this.getCompany(newData.company["@id"].split("/")[2]);
      }
    }
  },
  methods: {
    ...mapActions("adminProduct", {
      getPage: "fetchAll",
      deleteItem: "del"
    }),
    ...mapActions("product", ["setProductLoadedState"]),
    ...mapActions("admin", ["getCompany", "getStoresByCompany"]),
    ...mapActions("user", ["getProfile"]),
    productCompany(item) {
      return this.company.stores.find(store =>
        store.products.find(product => product.id == item.id)
      );
    },
    customSort(items, index, isDescending) {
      items.sort((a, b) => {
        if (index === "store") {
          if (isDescending) {
            return b.store.id - a.store.id;
          } else {
            return a.store.id - b.store.id;
          }
        }
      });
      return items;
    }
  }
};
</script>
